Index: branches/HM-10.0-dev-SHM/source/Lib/TLibDecoder/TDecCAVLC.h
===================================================================
--- branches/HM-10.0-dev-SHM/source/Lib/TLibDecoder/TDecCAVLC.h	(revision 51)
+++ branches/HM-10.0-dev-SHM/source/Lib/TLibDecoder/TDecCAVLC.h	(revision 54)
@@ -120,4 +120,8 @@
   Void updateContextTables  ( SliceType /*eSliceType*/, Int /*iQp*/ ) { return; }
 
+#if INTRA_BL
+  Void parseIntraBLFlag     ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiPartIdx, UInt uiDepth );
+#endif
+
   Void xParsePredWeightTable ( TComSlice* pcSlice );
   Void  parseScalingList               ( TComScalingList* scalingList );
Index: branches/HM-10.0-dev-SHM/source/Lib/TLibDecoder/TDecCu.cpp
===================================================================
--- branches/HM-10.0-dev-SHM/source/Lib/TLibDecoder/TDecCu.cpp	(revision 51)
+++ branches/HM-10.0-dev-SHM/source/Lib/TLibDecoder/TDecCu.cpp	(revision 54)
@@ -37,4 +37,8 @@
 
 #include "TDecCu.h"
+#if SVC_EXTENSION
+#include "TDecTop.h"
+#endif
+
 
 //! \ingroup TLibDecoder
@@ -56,4 +60,19 @@
 }
 
+#if SVC_EXTENSION
+Void TDecCu::init(TDecTop** ppcDecTop, TDecEntropy* pcEntropyDecoder, TComTrQuant* pcTrQuant, TComPrediction* pcPrediction, UInt layerId)
+{
+  m_pcEntropyDecoder  = pcEntropyDecoder;
+  m_pcTrQuant         = pcTrQuant;
+  m_pcPrediction      = pcPrediction; 
+  m_ppcTDecTop = ppcDecTop;
+  m_layerId = layerId; 
+
+  for ( UInt ui = 0; ui < m_uiMaxDepth-1; ui++ )
+  {
+    m_ppcCU     [ui]->setLayerId(layerId);
+  }
+}
+#else
 Void TDecCu::init( TDecEntropy* pcEntropyDecoder, TComTrQuant* pcTrQuant, TComPrediction* pcPrediction)
 {
@@ -62,4 +81,5 @@
   m_pcPrediction      = pcPrediction;
 }
+#endif
 
 /**
@@ -128,4 +148,7 @@
 
   // start from the top level CU
+#if SVC_EXTENSION
+  pcCU->setLayerId(m_layerId);
+#endif
   xDecodeCU( pcCU, 0, 0, ruiIsLast);
 }
@@ -311,4 +334,13 @@
     return;
   }
+#if INTRA_BL
+  m_pcEntropyDecoder->decodeIntraBLFlag( pcCU, uiAbsPartIdx, 0, uiDepth );
+  if ( pcCU->isIntraBL( uiAbsPartIdx ) )
+  {
+    pcCU->setSizeSubParts( g_uiMaxCUWidth>>uiDepth, g_uiMaxCUHeight>>uiDepth, uiAbsPartIdx, uiDepth ); 
+  }
+  else
+  {
+#endif
 
   m_pcEntropyDecoder->decodePredMode( pcCU, uiAbsPartIdx, uiDepth );
@@ -325,10 +357,17 @@
     }
   }
+#if INTRA_BL
+  // prediction mode ( Intra : direction mode, Inter : Mv, reference idx )
+  m_pcEntropyDecoder->decodePredInfo( pcCU, uiAbsPartIdx, uiDepth, m_ppcCU[uiDepth]);
+  }
+#endif
 
   UInt uiCurrWidth      = pcCU->getWidth ( uiAbsPartIdx );
   UInt uiCurrHeight     = pcCU->getHeight( uiAbsPartIdx );
   
+#if !INTRA_BL
   // prediction mode ( Intra : direction mode, Inter : Mv, reference idx )
   m_pcEntropyDecoder->decodePredInfo( pcCU, uiAbsPartIdx, uiDepth, m_ppcCU[uiDepth]);
+#endif
   
   // Coefficient decoding
@@ -401,4 +440,13 @@
       xReconIntraQT( m_ppcCU[uiDepth], uiDepth );
       break;
+#if INTRA_BL
+    case MODE_INTRA_BL:
+#if NO_RESIDUAL_FLAG_FOR_BLPRED
+      xReconIntraBL( m_ppcCU[uiDepth], uiAbsPartIdx, uiDepth );
+#else
+      xReconIntraQT( m_ppcCU[uiDepth], uiAbsPartIdx, uiDepth );
+#endif
+      break;
+#endif
     default:
       assert(0);
@@ -468,4 +516,11 @@
   
   //===== get prediction signal =====
+#if INTRA_BL && !NO_RESIDUAL_FLAG_FOR_BLPRED
+  if(pcCU->isIntraBL ( uiAbsPartIdx ) )
+  {
+    pcCU->getBaseLumaBlk( uiWidth, uiHeight, uiAbsPartIdx, piPred, uiStride );
+  }
+  else
+#endif
   m_pcPrediction->predIntraLumaAng( pcCU->getPattern(), uiLumaPredMode, piPred, uiStride, uiWidth, uiHeight, bAboveAvail, bLeftAvail );
   
@@ -552,4 +607,11 @@
   
   //===== get prediction signal =====
+#if INTRA_BL && !NO_RESIDUAL_FLAG_FOR_BLPRED
+  if(pcCU->isIntraBL ( uiAbsPartIdx ) )
+  {
+    pcCU->getBaseChromaBlk( uiWidth, uiHeight, uiAbsPartIdx, piPred, uiStride, uiChromaId );
+  }
+  else
+#endif
   {
     if( uiChromaPredMode == DM_CHROMA_IDX )
@@ -869,3 +931,26 @@
 }
 
+#if NO_RESIDUAL_FLAG_FOR_BLPRED
+Void
+TDecCu::xReconIntraBL( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth )
+{
+  m_ppcYuvReco[uiDepth]->copyFromPicLuma  ( pcCU->getSlice()->getFullPelBaseRec(),  pcCU->getAddr(), pcCU->getZorderIdxInCU(), 0, pcCU->getWidth(0), pcCU->getHeight(0));
+  m_ppcYuvReco[uiDepth]->copyFromPicChroma( pcCU->getSlice()->getFullPelBaseRec(),  pcCU->getAddr(), pcCU->getZorderIdxInCU(), 0, (pcCU->getWidth(0)>>1), (pcCU->getHeight(0)>>1), 0);
+  m_ppcYuvReco[uiDepth]->copyFromPicChroma( pcCU->getSlice()->getFullPelBaseRec(),  pcCU->getAddr(), pcCU->getZorderIdxInCU(), 0, (pcCU->getWidth(0)>>1), (pcCU->getHeight(0)>>1), 1);
+
+  // inter recon
+  xDecodeInterTexture( pcCU, 0, uiDepth );
+
+  // clip for only non-zero cbp case
+  if  ( ( pcCU->getCbf( 0, TEXT_LUMA ) ) || ( pcCU->getCbf( 0, TEXT_CHROMA_U ) ) || ( pcCU->getCbf(0, TEXT_CHROMA_V ) ) )
+  {
+    m_ppcYuvReco[uiDepth]->addClip( m_ppcYuvReco[uiDepth], m_ppcYuvResi[uiDepth], 0, pcCU->getWidth( 0 ) );
+  }
+  else
+  {
+    m_ppcYuvReco[uiDepth]->copyPartToPartYuv( m_ppcYuvReco[uiDepth],0, pcCU->getWidth( 0 ),pcCU->getHeight( 0 ));
+  }
+}
+#endif
+
 //! \}
Index: branches/HM-10.0-dev-SHM/source/Lib/TLibDecoder/TDecCu.h
===================================================================
--- branches/HM-10.0-dev-SHM/source/Lib/TLibDecoder/TDecCu.h	(revision 51)
+++ branches/HM-10.0-dev-SHM/source/Lib/TLibDecoder/TDecCu.h	(revision 54)
@@ -49,4 +49,7 @@
 //! \ingroup TLibDecoder
 //! \{
+#if SVC_EXTENSION
+class TDecTop;
+#endif
 
 // ====================================================================================================================
@@ -69,4 +72,12 @@
 
   Bool                m_bDecodeDQP;
+#if SVC_EXTENSION
+  TDecTop**           m_ppcTDecTop;
+  UInt                m_layerId;   
+#endif
+  
+#if INTRA_BL
+  TComPicYuv*         m_pcPicYuvRecBase;       ///< reconstructed base layer
+#endif 
   
 public:
@@ -75,5 +86,9 @@
   
   /// initialize access channels
+#if SVC_EXTENSION
+  Void  init                    ( TDecTop** ppcDecTop, TDecEntropy* pcEntropyDecoder, TComTrQuant* pcTrQuant, TComPrediction* pcPrediction, UInt layerId );
+#else
   Void  init                    ( TDecEntropy* pcEntropyDecoder, TComTrQuant* pcTrQuant, TComPrediction* pcPrediction );
+#endif 
   
   /// create internal buffers
@@ -89,4 +104,10 @@
   Void  decompressCU            ( TComDataCU* pcCU );
   
+#if SVC_EXTENSION
+  TDecTop*   getLayerDec        ( UInt LayerId )  { return m_ppcTDecTop[LayerId]; }
+#if INTRA_BL
+  Void  setBaseRecPic           ( TComPicYuv* p ) { m_pcPicYuvRecBase = p; }
+#endif 
+#endif
 protected:
   
@@ -101,4 +122,7 @@
   Void  xIntraRecLumaBlk        ( TComDataCU* pcCU, UInt uiTrDepth, UInt uiAbsPartIdx, TComYuv* pcRecoYuv, TComYuv* pcPredYuv, TComYuv* pcResiYuv );
   Void  xIntraRecChromaBlk      ( TComDataCU* pcCU, UInt uiTrDepth, UInt uiAbsPartIdx, TComYuv* pcRecoYuv, TComYuv* pcPredYuv, TComYuv* pcResiYuv, UInt uiChromaId );
+#if NO_RESIDUAL_FLAG_FOR_BLPRED
+  Void  xReconIntraBL           ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth );
+#endif
   
   Void  xReconPCM               ( TComDataCU* pcCU, UInt uiDepth );
Index: branches/HM-10.0-dev-SHM/source/Lib/TLibDecoder/TDecEntropy.cpp
===================================================================
--- branches/HM-10.0-dev-SHM/source/Lib/TLibDecoder/TDecEntropy.cpp	(revision 51)
+++ branches/HM-10.0-dev-SHM/source/Lib/TLibDecoder/TDecEntropy.cpp	(revision 54)
@@ -58,4 +58,11 @@
 }
 
+#if INTRA_BL
+Void TDecEntropy::decodeIntraBLFlag( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiPartIdx, UInt uiDepth )
+{
+  m_pcEntropyDecoderIf->parseIntraBLFlag( pcCU, uiAbsPartIdx, uiPartIdx, uiDepth );
+}
+#endif
+
 /** decode merge flag
  * \param pcSubCU
@@ -104,4 +111,10 @@
 Void TDecEntropy::decodePredInfo    ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth, TComDataCU* pcSubCU )
 {
+#if INTRA_BL
+  if( pcCU->isIntraBL( uiAbsPartIdx ) )                                 // Do nothing for Intra BL mode.
+  {
+    return;
+  }
+#endif
   if( pcCU->isIntra( uiAbsPartIdx ) )                                 // If it is Intra mode, encode intra prediction mode.
   {
@@ -175,4 +188,14 @@
       decodeMergeIndex( pcCU, uiPartIdx, uiSubPartIdx, uiDepth );
       UInt uiMergeIndex = pcCU->getMergeIndex(uiSubPartIdx);
+#if REF_IDX_FRAMEWORK  // HM bug fix
+      if(uiPartIdx)
+      {
+        for(UInt ui=0; ui<uiMergeIndex+1; ui++)
+        {
+          cMvFieldNeighbours[(ui<<1)].setMvField(TComMv(), NOT_VALID);
+          cMvFieldNeighbours[(ui<<1)+1].setMvField(TComMv(), NOT_VALID);
+        }
+      }
+#endif
       if ( pcCU->getSlice()->getPPS()->getLog2ParallelMergeLevelMinus2() && ePartSize != SIZE_2Nx2N && pcSubCU->getWidth( 0 ) <= 8 ) 
       {
@@ -437,5 +460,13 @@
     
     pcCU->setCbfSubParts ( 0, TEXT_LUMA, uiAbsPartIdx, uiDepth );
+#if INTRA_BL
+#if NO_RESIDUAL_FLAG_FOR_BLPRED
+    if( ( !pcCU->isIntra(uiAbsPartIdx) || pcCU->isIntraBL(uiAbsPartIdx)) && uiDepth == pcCU->getDepth( uiAbsPartIdx ) && !pcCU->getCbf( uiAbsPartIdx, TEXT_CHROMA_U, 0 ) && !pcCU->getCbf( uiAbsPartIdx, TEXT_CHROMA_V, 0 ) )
+#else
+    if( ( !pcCU->isIntra(uiAbsPartIdx) ) && uiDepth == pcCU->getDepth( uiAbsPartIdx ) && !pcCU->getCbf( uiAbsPartIdx, TEXT_CHROMA_U, 0 ) && !pcCU->getCbf( uiAbsPartIdx, TEXT_CHROMA_V, 0 ) )
+#endif
+#else
     if( pcCU->getPredictionMode(uiAbsPartIdx) != MODE_INTRA && uiDepth == pcCU->getDepth( uiAbsPartIdx ) && !pcCU->getCbf( uiAbsPartIdx, TEXT_CHROMA_U, 0 ) && !pcCU->getCbf( uiAbsPartIdx, TEXT_CHROMA_V, 0 ) )
+#endif 
     {
       pcCU->setCbfSubParts( 1 << uiTrDepth, TEXT_LUMA, uiAbsPartIdx, uiDepth );
@@ -535,5 +566,9 @@
   UInt uiChromaOffset = uiLumaOffset>>2;
   
+#if NO_RESIDUAL_FLAG_FOR_BLPRED
+  if( pcCU->isIntra(uiAbsPartIdx) && !pcCU->isIntraBL(uiAbsPartIdx) )
+#else
   if( pcCU->isIntra(uiAbsPartIdx) )
+#endif
   {
   }
Index: branches/HM-10.0-dev-SHM/source/Lib/TLibDecoder/TDecEntropy.h
===================================================================
--- branches/HM-10.0-dev-SHM/source/Lib/TLibDecoder/TDecEntropy.h	(revision 51)
+++ branches/HM-10.0-dev-SHM/source/Lib/TLibDecoder/TDecEntropy.h	(revision 54)
@@ -102,4 +102,9 @@
   virtual Void parseCoeffNxN( TComDataCU* pcCU, TCoeff* pcCoef, UInt uiAbsPartIdx, UInt uiWidth, UInt uiHeight, UInt uiDepth, TextType eTType ) = 0;
   virtual Void parseTransformSkipFlags ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt width, UInt height, UInt uiDepth, TextType eTType) = 0;
+
+#if INTRA_BL
+  virtual Void parseIntraBLFlag   ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiPartIdx, UInt uiDepth ) = 0;
+#endif
+
   virtual Void updateContextTables( SliceType eSliceType, Int iQp ) = 0;
   
@@ -157,4 +162,7 @@
   Void updateContextTables    ( SliceType eSliceType, Int iQp ) { m_pcEntropyDecoderIf->updateContextTables( eSliceType, iQp ); }
   
+#if INTRA_BL
+  Void decodeIntraBLFlag       ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiPartIdx, UInt uiDepth );
+#endif
   
 private:
Index: branches/HM-10.0-dev-SHM/source/Lib/TLibDecoder/TDecGop.cpp
===================================================================
--- branches/HM-10.0-dev-SHM/source/Lib/TLibDecoder/TDecGop.cpp	(revision 51)
+++ branches/HM-10.0-dev-SHM/source/Lib/TLibDecoder/TDecGop.cpp	(revision 54)
@@ -43,4 +43,7 @@
 #include "libmd5/MD5.h"
 #include "TLibCommon/SEI.h"
+#if SVC_EXTENSION
+#include "TDecTop.h"
+#endif
 
 #include <time.h>
@@ -67,15 +70,25 @@
 }
 
+#if SVC_EXTENSION
+Void TDecGop::create(UInt layerId)
+{
+  m_layerId = layerId;
+}
+#else
 Void TDecGop::create()
 {
   
 }
-
+#endif
 
 Void TDecGop::destroy()
 {
 }
-
+#if SVC_EXTENSION
+Void TDecGop::init(TDecTop**               ppcDecTop,
+                   TDecEntropy*            pcEntropyDecoder,
+#else
 Void TDecGop::init( TDecEntropy*            pcEntropyDecoder, 
+#endif
                    TDecSbac*               pcSbacDecoder, 
                    TDecBinCABAC*           pcBinCABAC,
@@ -93,4 +106,7 @@
   m_pcLoopFilter          = pcLoopFilter;
   m_pcSAO  = pcSAO;
+#if SVC_EXTENSION   
+  m_ppcTDecTop            = ppcDecTop;
+#endif
 }
 
@@ -210,9 +226,16 @@
 
   //-- For time output for each slice
+#if SVC_EXTENSION
+  printf("\nPOC %4d LId: %1d TId: %1d ( %c-SLICE, QP%3d ) ", pcSlice->getPOC(),
+                                                    rpcPic->getLayerId(),
+                                                    pcSlice->getTLayer(),
+                                                    c,
+                                                    pcSlice->getSliceQp() );
+#else
   printf("\nPOC %4d TId: %1d ( %c-SLICE, QP%3d ) ", pcSlice->getPOC(),
                                                     pcSlice->getTLayer(),
                                                     c,
                                                     pcSlice->getSliceQp() );
-
+#endif
   m_dDecTime += (Double)(clock()-iBeforeTime) / CLOCKS_PER_SEC;
   printf ("[DT %6.3f] ", m_dDecTime );
Index: branches/HM-10.0-dev-SHM/source/Lib/TLibDecoder/TDecGop.h
===================================================================
--- branches/HM-10.0-dev-SHM/source/Lib/TLibDecoder/TDecGop.h	(revision 51)
+++ branches/HM-10.0-dev-SHM/source/Lib/TLibDecoder/TDecGop.h	(revision 54)
@@ -87,9 +87,18 @@
   std::vector<Bool> m_LFCrossSliceBoundaryFlag;
 
+#if SVC_EXTENSION
+  UInt                  m_layerId;
+  TDecTop**             m_ppcTDecTop;
+#endif
 public:
   TDecGop();
   virtual ~TDecGop();
   
+#if SVC_EXTENSION
+Void  init      ( TDecTop**               ppcDecTop,
+                  TDecEntropy*            pcEntropyDecoder, 
+#else
   Void  init    ( TDecEntropy*            pcEntropyDecoder, 
+#endif
                  TDecSbac*               pcSbacDecoder, 
                  TDecBinCABAC*           pcBinCABAC,
@@ -99,5 +108,9 @@
                  TComSampleAdaptiveOffset* pcSAO
                  );
+#if SVC_EXTENSION
+  Void  create  (UInt layerId);
+#else
   Void  create  ();
+#endif
   Void  destroy ();
   Void  decompressSlice(TComInputBitstream* pcBitstream, TComPic*& rpcPic );
@@ -105,4 +118,7 @@
 
   void setDecodedPictureHashSEIEnabled(Int enabled) { m_decodedPictureHashSEIEnabled = enabled; }
+#if SVC_EXTENSION
+  TDecTop*   getLayerDec(UInt LayerId)  { return m_ppcTDecTop[LayerId]; }
+#endif 
 
 };
Index: branches/HM-10.0-dev-SHM/source/Lib/TLibDecoder/TDecSbac.cpp
===================================================================
--- branches/HM-10.0-dev-SHM/source/Lib/TLibDecoder/TDecSbac.cpp	(revision 51)
+++ branches/HM-10.0-dev-SHM/source/Lib/TLibDecoder/TDecSbac.cpp	(revision 54)
@@ -77,4 +77,7 @@
 , m_cTransformSkipSCModel     ( 1,             2,               NUM_TRANSFORMSKIP_FLAG_CTX    , m_contextModels + m_numContextModels, m_numContextModels)
 , m_CUTransquantBypassFlagSCModel( 1,          1,               NUM_CU_TRANSQUANT_BYPASS_FLAG_CTX, m_contextModels + m_numContextModels, m_numContextModels)
+#if INTRA_BL
+, m_cIntraBLPredFlagSCModel   (1,              1,               NUM_INTRA_BL_PRED_CTX         , m_contextModels + m_numContextModels, m_numContextModels)
+#endif
 {
   assert( m_numContextModels <= MAX_NUM_CTX_MOD );
@@ -135,4 +138,7 @@
 
   m_cCUTransSubdivFlagSCModel.initBuffer ( sliceType, qp, (UChar*)INIT_TRANS_SUBDIV_FLAG );
+#if INTRA_BL
+  m_cIntraBLPredFlagSCModel.initBuffer ( sliceType, qp, (UChar*)INIT_INTRA_BL_PRED_FLAG );
+#endif
   m_cTransformSkipSCModel.initBuffer     ( sliceType, qp, (UChar*)INIT_TRANSFORMSKIP_FLAG );
   m_CUTransquantBypassFlagSCModel.initBuffer( sliceType, qp, (UChar*)INIT_CU_TRANSQUANT_BYPASS_FLAG );
@@ -179,4 +185,7 @@
   m_cSaoTypeIdxSCModel.initBuffer        ( eSliceType, iQp, (UChar*)INIT_SAO_TYPE_IDX );
   m_cCUTransSubdivFlagSCModel.initBuffer ( eSliceType, iQp, (UChar*)INIT_TRANS_SUBDIV_FLAG );
+#if INTRA_BL
+  m_cIntraBLPredFlagSCModel.initBuffer ( eSliceType, iQp, (UChar*)INIT_INTRA_BL_PRED_FLAG );
+#endif
   m_cTransformSkipSCModel.initBuffer     ( eSliceType, iQp, (UChar*)INIT_TRANSFORMSKIP_FLAG );
   m_CUTransquantBypassFlagSCModel.initBuffer( eSliceType, iQp, (UChar*)INIT_CU_TRANSQUANT_BYPASS_FLAG );
@@ -431,4 +440,32 @@
 }
 
+#if INTRA_BL
+Void TDecSbac::parseIntraBLFlag( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiPartIdx, UInt uiDepth )
+{
+  if( pcCU->getLayerId() == 0 )
+  {
+    return;
+  }
+
+  UInt uiSymbol = 0;
+
+  UInt uiCtxIntraBL = pcCU->getCtxIntraBLFlag( uiAbsPartIdx ) ;
+  m_pcTDecBinIf->decodeBin( uiSymbol, m_cIntraBLPredFlagSCModel.get( 0, 0, uiCtxIntraBL )); 
+  DTRACE_CABAC_VL( g_nSymbolCounter++ );
+  DTRACE_CABAC_T( "\tIntrBLFlag" );
+  DTRACE_CABAC_T( "\tuiSymbol: ");
+  DTRACE_CABAC_V( uiSymbol );
+  DTRACE_CABAC_T( "\n");
+
+  if ( uiSymbol )
+  {
+    pcCU->setPartSizeSubParts( SIZE_2Nx2N, uiAbsPartIdx, uiDepth );
+    pcCU->setPredModeSubParts( MODE_INTRA_BL, uiAbsPartIdx, uiDepth );
+    pcCU->setTrIdxSubParts( 0, uiAbsPartIdx, uiDepth );
+    pcCU->setLumaIntraDirSubParts ( DC_IDX, uiAbsPartIdx, uiDepth );   
+  }
+}
+#endif
+
 /** parse merge flag
  * \param pcCU
@@ -521,4 +558,10 @@
   PartSize eMode;
   
+#if INTRA_BL
+  if ( pcCU->isIntraBL( uiAbsPartIdx ) )
+  {
+    assert( 0 );
+  }
+#endif
   if ( pcCU->isIntra( uiAbsPartIdx ) )
   {
Index: branches/HM-10.0-dev-SHM/source/Lib/TLibDecoder/TDecSbac.h
===================================================================
--- branches/HM-10.0-dev-SHM/source/Lib/TLibDecoder/TDecSbac.h	(revision 51)
+++ branches/HM-10.0-dev-SHM/source/Lib/TLibDecoder/TDecSbac.h	(revision 54)
@@ -131,4 +131,7 @@
   Void  parseScalingList ( TComScalingList* /*scalingList*/ ) {}
 
+#if INTRA_BL
+  Void parseIntraBLFlag    ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiPartIdx, UInt uiDepth );
+#endif
 private:
   UInt m_uiLastDQpNonZero;
@@ -167,4 +170,7 @@
   ContextModel3DBuffer m_cTransformSkipSCModel;
   ContextModel3DBuffer m_CUTransquantBypassFlagSCModel;
+#if INTRA_BL
+  ContextModel3DBuffer m_cIntraBLPredFlagSCModel;
+#endif
 };
 
Index: branches/HM-10.0-dev-SHM/source/Lib/TLibDecoder/TDecSlice.cpp
===================================================================
--- branches/HM-10.0-dev-SHM/source/Lib/TLibDecoder/TDecSlice.cpp	(revision 51)
+++ branches/HM-10.0-dev-SHM/source/Lib/TLibDecoder/TDecSlice.cpp	(revision 54)
@@ -100,9 +100,18 @@
 }
 
-Void TDecSlice::init(TDecEntropy* pcEntropyDecoder, TDecCu* pcCuDecoder)
+#if SVC_EXTENSION
+Void TDecSlice::init(TDecTop** ppcDecTop,TDecEntropy* pcEntropyDecoder, TDecCu* pcCuDecoder)
 {
   m_pcEntropyDecoder  = pcEntropyDecoder;
   m_pcCuDecoder       = pcCuDecoder;
-}
+  m_ppcTDecTop        = ppcDecTop;
+}
+#else
+Void TDecSlice::init(TDecEntropy* pcEntropyDecoder, TDecCu* pcCuDecoder)
+{
+  m_pcEntropyDecoder  = pcEntropyDecoder;
+  m_pcCuDecoder       = pcCuDecoder;
+}
+#endif
 
 Void TDecSlice::decompressSlice(TComInputBitstream** ppcSubstreams, TComPic*& rpcPic, TDecSbac* pcSbacDecoder, TDecSbac* pcSbacDecoders)
@@ -184,4 +193,7 @@
   UInt uiTileLCUX;
   Int iNumSubstreamsPerTile = 1; // if independent.
+#if INTRA_BL
+  m_pcCuDecoder->setBaseRecPic( rpcPic->getLayerId() > 0 ? rpcPic->getFullPelBaseRec() : NULL);
+#endif
   Bool depSliceSegmentsEnabled = rpcPic->getSlice(rpcPic->getCurrSliceIdx())->getPPS()->getDependentSliceSegmentsEnabledFlag();
   uiTileStartLCU = rpcPic->getPicSym()->getTComTile(rpcPic->getPicSym()->getTileIdxMap(iStartCUAddr))->getFirstCUAddr();
Index: branches/HM-10.0-dev-SHM/source/Lib/TLibDecoder/TDecSlice.h
===================================================================
--- branches/HM-10.0-dev-SHM/source/Lib/TLibDecoder/TDecSlice.h	(revision 51)
+++ branches/HM-10.0-dev-SHM/source/Lib/TLibDecoder/TDecSlice.h	(revision 54)
@@ -72,4 +72,7 @@
   TDecBinCABAC*   m_pcBufferLowLatBinCABACs;
   std::vector<TDecSbac*> CTXMem;
+#if SVC_EXTENSION
+  TDecTop**       m_ppcTDecTop;
+#endif 
   
 public:
@@ -77,5 +80,9 @@
   virtual ~TDecSlice();
   
+#if SVC_EXTENSION  
+  Void  init              ( TDecTop** ppcDecTop, TDecEntropy* pcEntropyDecoder, TDecCu* pcMbDecoder );
+#else
   Void  init              ( TDecEntropy* pcEntropyDecoder, TDecCu* pcMbDecoder );
+#endif
   Void  create            ();
   Void  destroy           ();
@@ -84,4 +91,7 @@
   Void      initCtxMem(  UInt i );
   Void      setCtxMem( TDecSbac* sb, Int b )   { CTXMem[b] = sb; }
+#if SVC_EXTENSION
+  TDecTop*  getLayerDec   ( UInt LayerId )  { return m_ppcTDecTop[LayerId]; }  
+#endif
 };
 
